/*  -------------------------------------------------------------------

This program is the property of:

                             Cornell University 
                        Center for Applied Mathematics 
                              Ithaca, NY 14853

and may be used, modified and distributed freely, subject to the 
following restrictions:

       Any product which incorporates source code from the dstool
       program or utilities, in whole or in part, is distributed
       with a copy of that source code, including this notice. You
       must give the recipients all the rights that you have with
       respect to the use of this software. Modifications of the
       software must carry prominent notices stating who changed
       the files and the date of any change.

DsTool is distributed in the hope that it will be useful, but 
WITHOUT ANY WARRANTY; without even the implied warranty of FITNESS 
FOR A PARTICULAR PURPOSE.  The software is provided as is without 
any obligation on the part of Cornell faculty, staff or students to 
assist in its use, correction, modification or enhancement.

  -----------------------------------------------------------------  */

extern void print_vector (int n, double *v);
extern double dot (int dim, double *u, double *v);
extern double L2_norm (int dim, double *v);
extern double L2_norm_sqr (int dim, double *v);
extern double euclid_dist (int dim, double *u, double *v);
extern double euclid_dist_sqr (int dim, double *u, double *v);
extern double *normalize (int dim, double *v);
extern double *proj_vector (int dim, double *u, double *v, double *w);
                  		/* w = proj of u onto v
				   assumes w allocated
				  ARGS: (dim,u,v,w) */
extern double *orthog_vector (int dim, double *u, double *v, double *w);
                                /* w = proj of v orthogonal to u
				   assumes w allocated
				   ARGS: (dim,u,v,w) */
extern double cos_between (int dim, double *u, double *v);
extern int same_side (int dim, double *c, double *v, double *u);
